/*
   orxonox - the future of 3D-vertical-scrollers

   Copyright (C) 2004 orx

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

### File Specific:
   main-programmer: Patrick Boenzli
*/

#define DEBUG_MODULE_GAME_RULES

#include "singleplayer_shootemup.h"

#include "util/loading/load_param.h"
#include "util/loading/factory.h"

#include "render2D/billboard.h"
#include "state.h"
#include "class_list.h"

#include "player.h"
#include "playable.h"
#include "space_ships/space_ship.h"


#include "shared_network_data.h"
#include "terrain.h"
#include "class_list.h"
#include "space_ships/space_ship.h"


using namespace std;


CREATE_FACTORY(SingleplayerShootemup, CL_SINGLEPLAYER_SHOOTEMUP);



/**
 * constructor
 */
SingleplayerShootemup::SingleplayerShootemup(const TiXmlElement* root)
  : GameRules(root)
{
  this->setClassID(CL_SINGLEPLAYER_SHOOTEMUP, "SingleplayerShootemup");

  if( root != NULL)
    this->loadParams(root);
}

/**
 * decontsructor
 */
SingleplayerShootemup::~SingleplayerShootemup()
{
}



void SingleplayerShootemup::loadParams(const TiXmlElement* root)
{
  GameRules::loadParams(root) ;

//   LoadParam(root, "death-penalty-timeout", this, SingleplayerShootemup, setDeathPenaltyTimeout)
//       .describe("sets the time in seconds a player has to wait for respawn");
//
//   LoadParam(root, "max-kills", this, SingleplayerShootemup, setMaxKills)
//       .describe("sets the maximal kills for winning condition");
//
//   LoadParam(root, "death-screen-image", this, SingleplayerShootemup, setDeathScreen)
//       .describe("sets the death screen image");

}



void SingleplayerShootemup::setDeathScreen(const std::string& imageName)
{}



/**
 * called when the player enters the game
 * @param player the spawned player
 */
void SingleplayerShootemup::onPlayerSpawn()
{
}


/**
 * when the player is killed
 * @param player the killed player
 */
void SingleplayerShootemup::onPlayerDeath()
{
}


/**
 * time tick
 * @param dt time
 */
void SingleplayerShootemup::tick(float dt)
{
  this->checkGameRules();
}


/**
 * draws the stuff
 */
void SingleplayerShootemup::draw()
{}


/**
 * check the game rules for consistency
 */
void SingleplayerShootemup::checkGameRules()
{}






